<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\{Camera, PreviouslyOwnedCamera};
use Doctrine\ORM\{ORMInvalidArgumentException};

class CameraRepository extends AcquireRepository
{
    /**
     * @throws ORMInvalidArgumentException
     */
    public function deacquire(mixed $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(TRUE)
            ->setReceived(TRUE);

        $this->moveRecord($currentRecord, new PreviouslyOwnedCamera());
    }

    /**
     * @throws ORMInvalidArgumentException
     */
    public function reacquire(mixed $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(FALSE);

        $this->moveRecord($currentRecord, new Camera());
    }
}
