<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\{Lenses, PreviouslyOwnedLenses};

class LensesRepository extends AcquireRepository
{
    public function deacquire(mixed $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(TRUE)
            ->setReceived(TRUE);

        $this->moveRecord($currentRecord, new PreviouslyOwnedLenses());
    }

    public function reacquire(mixed $currentRecord): void
    {
        $currentRecord->setFormerlyOwned(FALSE);

        $this->moveRecord($currentRecord, new Lenses());
    }
}
